function FreqOut=DFT_FilterBank_Analysis_func(in_frame_seg,win, ref_out)
%%
persistent FrameCnt nNumChs nFrmLen FFTLen FreqSamplingFactor WinCompenGain exp_k nHopSize

if isempty(FrameCnt)
    FrameCnt=0;
    nNumChs=size(ref_out,1);
    nHopSize=size(in_frame_seg,1);
    nFrmLen=size(win,1);%ceil(nHopSize*4); % 3 4,5,6
%     win=hamming(nFrmLen);
    % %     WOLA rectangular (1~2), hamming(3~6), Blackman Family(5~10)
    % %     COLA rectangular (1~2), hamming(2~4), Blackman Family(3~6)
    
    FFTLen=2^(ceil(log(nFrmLen)/log(2)));
    FreqSamplingFactor=floor(FFTLen/(nNumChs*2));
    WinCompenGain=sum(win(1:nHopSize:nFrmLen).^2);  % WOLA;, if COLA; win_compen_gain=sum(win(1:R:nFrmLen).^1);

    wk=2*pi*nHopSize*(0:1:FFTLen-1)'/(FFTLen);
    exp_k=1j*zeros(FFTLen,nFrmLen/nHopSize);
    for mod_i=0:nFrmLen/nHopSize-1
        exp_k(:,mod_i+1)=exp(1j*wk*mod_i);
    end
end

%%
BufferFrame = Buffering_func(in_frame_seg,nFrmLen)/(nFrmLen/nHopSize);
WinBufferFrame=win.*BufferFrame;

ZeroPadSig=zeros(FFTLen,1);
ZeroPadSig(1:nFrmLen)=WinBufferFrame;
FFTSig=fft(ZeroPadSig,FFTLen);
FFTSig2=(FreqSamplingFactor/WinCompenGain)*FFTSig;
FreqOut=1j*zeros(size(ref_out));
FreqOut(1:size(ref_out,1),1)=exp_k(1:FreqSamplingFactor:FFTLen/2,1+mod(FrameCnt,nFrmLen/nHopSize)).*FFTSig2(1:FreqSamplingFactor:FFTLen/2);
FrameCnt=mod(FrameCnt+1,nFrmLen/nHopSize);
end

%%
function frame_out = Buffering_func(in_frame_seg,Out_nFrmLen)
In_nFrmLen=size(in_frame_seg,1);
persistent  inbuf;
if isempty(inbuf)
    inbuf=zeros(Out_nFrmLen,1);
end
inbuf(1:Out_nFrmLen-In_nFrmLen,:)=inbuf(In_nFrmLen+1:Out_nFrmLen,:);
inbuf(Out_nFrmLen-In_nFrmLen+1:Out_nFrmLen,:)=in_frame_seg;
frame_out=inbuf;
end
%%
