function TimeSegOut=DFT_FilterBank_Synthesis_func(FreqIn, win, ref_out)
%%
persistent FrameCnt nNumChs nFrmLen FFTLen FreqSamplingFactor nHopSize  exp_k

if isempty(FrameCnt)
    FrameCnt=0;
    nNumChs=size(FreqIn,1);
    nHopSize=size(ref_out,1);
    nFrmLen=size(win,1);%ceil(nHopSize*4); % 3 4,5,6
%     win=hamming(nFrmLen);
    % %     WOLA rectangular (1~2), hamming(3~6), Blackman Family(5~10)
    % %     COLA rectangular (1~2), hamming(2~4), Blackman Family(3~6)
    
    FFTLen=2^(ceil(log(nFrmLen)/log(2)));
    FreqSamplingFactor=floor(FFTLen/(nNumChs*2));
    
    wk=2*pi*nHopSize*(0:1:FFTLen-1)'/(FFTLen);
    exp_k=1j*zeros(FFTLen,nFrmLen/nHopSize);
    for mod_i=0:nFrmLen/nHopSize-1
        exp_k(:,mod_i+1)=exp(1j*wk*mod_i);
    end
end
%%
FreqSig=1j*zeros(nNumChs,1);
FreqSig(1:size(FreqIn,1),1)=conj(exp_k(1:FreqSamplingFactor:FFTLen/2,1+mod(FrameCnt,nFrmLen/nHopSize))).*FreqIn;
FrameCnt=mod(FrameCnt+1,nFrmLen/nHopSize);

FreqSig2=[upsample(FreqSig,FreqSamplingFactor); 0];
FreqSig3=[FreqSig2;  conj(FreqSig2(FFTLen/2:-1:2))];
%%
TimeFrameSig=ifft(FreqSig3); % inverse FFT
WinTimeFrameSig=win.*real(TimeFrameSig(1:nFrmLen));
%% Overlap and Add
TimeSegOut=zeros(size(ref_out));
TimeSegOut(1:size(ref_out,1),1) = OLA_func(WinTimeFrameSig,nHopSize)*(nFrmLen/nHopSize);
end

%%
function frame_seg_out = OLA_func(in_frame, out_nFrmLen)

in_nFrmLen=size(in_frame,1);
nNumChs=size(in_frame,2);
persistent prebuf;
if isempty(prebuf)
    prebuf=zeros(in_nFrmLen,nNumChs);
end

current_buf=real(in_frame)+prebuf;
frame_seg_out=zeros(out_nFrmLen,nNumChs);
frame_seg_out(1:out_nFrmLen,1:nNumChs)=current_buf(1:out_nFrmLen,1:nNumChs);

prebuf(1:in_nFrmLen-out_nFrmLen,1:nNumChs)=current_buf(out_nFrmLen+1:in_nFrmLen,1:nNumChs);
end
%%
