function y = PD_clipping_block(x, fs, tauAttack, tauRelease,Threshold,ratio,KneeWidth)
nFrmLen=size(x,1);

lx=20*log10(max(abs(real(x)), 1e-6));
persistent   state;
if isempty(state);
    state = 0;
end
taufs = tauAttack * fs;
if tauAttack > 0
    alphaAtt = exp(-1 / taufs);
else
    alphaAtt = 0;
end
taufs = tauRelease * fs;
if tauRelease > 0
    alphaRel = exp(-1 / taufs);
else
    alphaRel = 0;
end

y=zeros(nFrmLen,1);
for si=1:nFrmLen
    if lx(si) > state
        state =alphaAtt* state + (1-alphaAtt) * lx(si) ;
    else
        state =alphaRel* state + (1-alphaRel) * lx(si) ;
    end
    ly = state;
    
    %%
    slope = 1 / ratio - 1;% Feed-forward topology
    overshoot = ly - Threshold;
    if KneeWidth > 0% Soft half-wave rectifier
        w2 = KneeWidth / 2;
        a = w2 / (KneeWidth * KneeWidth);
        inTransition = ((overshoot > -w2) & (overshoot < w2));
        rect = inTransition .* (a * (overshoot + w2) .^ 2) + (1 - inTransition) .* max(overshoot, 0);
    else% Hard half-wave rectifier
        rect = max(overshoot, 0);
    end
    cv =rect * slope;% Multiply rectified overshoot with slope
    y(si,1) = x(si)*(10.^(cv./20));
    
end


