
function y = PDbranchingsmooth_sm(x, fs, tauAttack, tauRelease)
nNumChs=size(x,1);
persistent state;
if isempty(state);
    state = zeros(nNumChs,1);
end
y=zeros(nNumChs,1);

for ch_i=1:nNumChs
    %%
    if tauAttack(ch_i) > 0
        taufs = tauAttack(ch_i) * fs;
        alphaAtt = exp(-1 / taufs);
    else
        alphaAtt = 0;
    end
    %%
    if tauRelease(ch_i) > 0
        taufs = tauRelease(ch_i) * fs;
        alphaRel = exp(-1 / taufs);
    else
        alphaRel = 0;
    end
    %%    
    if x(ch_i) > state(ch_i)
        state(ch_i) =alphaAtt* state(ch_i) + (1-alphaAtt) * x(ch_i) ;
    else
        state(ch_i) =alphaRel* state(ch_i) + (1-alphaRel) * x(ch_i) ;
    end
    y(ch_i,1) = state(ch_i);
end
