clear all; clc; close all;
[x,fs]=wavread('BKBQ0201_16kHz');x=x/2;
nNumChs=32*1;
nHopSize=nNumChs/2;
nFrmLen=ceil(nHopSize*6); % 3 4,5,6
%%
sample_point=1;
y=[];FB_out=[]; 
%%
load('hrir_final.mat');
hrir=squeeze(hrir_l(13,9,:));
sim_ir=downsample(hrir,2);
sim_ir=sim_ir(10:60)/(1.9);
%%
if 1   % feedback path training
    random_noise=2*rand(fs*10,1)-1;
    random_noise_fb=filter(sim_ir,1,random_noise);
    hlms0 = dsp.LMSFilter(2*64,'StepSize',0.002,'LeakageFactor',1);
    [y0,e0,h0] = step(hlms0,random_noise,random_noise_fb);
else
    h0=zeros(2*64,1);
end
%%
pre_frame_seg_out=zeros(nHopSize,1);
%%
frame_i=1;cnt=0;
while (sample_point < (size(x,1)-nHopSize))
    in_frame_seg=x(sample_point:sample_point+nHopSize-1);          % Get nHopSize new samples
    if 1
        in_feedback_seg = feedback_signal_generation_func(sim_ir,pre_frame_seg_out);
        in_frame_seg=in_frame_seg+in_feedback_seg;
    end
    
    if 1
        step_size=0.002/1;
        [in_frame_seg,estimated_h] = AFC_NLMS_func(in_frame_seg,pre_frame_seg_out,h0,step_size);
    end
    
    ref_out=zeros(nNumChs,1);
    win=hamming(ceil(nFrmLen));
    %WOLA rectangular (1~2), hamming(3~6), Blackman Family(5~10)
    %COLA rectangular (1~2), hamming(2~4), Blackman Family(3~6)
    FreqOut=DFT_FilterBank_Analysis_func(in_frame_seg,win, ref_out);
    %%
    % Processing
  
    %%
    tauAttack =linspace(0.002, 0.02, nNumChs);
    tauRelease = linspace(0.04, 0.4, nNumChs);
    yp=PDbranchingsmooth_sm(abs(real(FreqOut)), fs/nHopSize, tauAttack, tauRelease);
    lg = 20*log10(max(yp, 1e-6))+120;
    %%
    ER=1/4;
    LT=110;         LR=8;
    Lmax=120;
    Lref=85;
    %%
    CT= linspace(50,40, nNumChs);
    ET=0*linspace(40,40,nNumChs);
    
    CR=linspace(1.1,2.2,nNumChs);
    Gref=linspace(5,15,nNumChs);
    %%
    gain=WDRC_HR(lg, ET, ER, CT, CR, LT, LR, Lmax, Lref, Gref);
    FreqOut=FreqOut.*gain;
    FB_out =[FB_out ; real(FreqOut.')];        
    %%
    if 1   % Phase modulation for frequency shifting
        Pm_freq=20;
        FFTLen=2^(ceil(log(nFrmLen)/log(2)));
        Pm_wk=((2*Pm_freq/fs)* 2*pi*nHopSize*(0:1:FFTLen-1)/(FFTLen)) * mod(cnt,nFrmLen/nHopSize);
        Pm_exp_k=exp(1j*Pm_wk(1:FFTLen/(nNumChs*2):FFTLen/2).');
        
        FreqOut=Pm_exp_k.*FreqOut;
        cnt=mod(cnt+1,nFrmLen/nHopSize);
    end  
    %%
    ref_out=zeros(nHopSize,1);
    TimeSegOut=DFT_FilterBank_Synthesis_func(FreqOut, win, ref_out);
    %%
    tauAttack = 0*0.0002;   tauRelease = 0*0.0004; Threshold=-1;   Ratio=8;KneeWidth=1;
    CTimeSegOut=PD_clipping_block(real(TimeSegOut),fs,tauAttack,tauRelease,Threshold,Ratio,KneeWidth);    %     CTimeSegOut=TimeSegOut;
    pre_frame_seg_out=CTimeSegOut;
    
    y=[y; CTimeSegOut];
    sample_point=sample_point+nHopSize;
end

% wavwrite(y,fs,'test1.wav');
soundsc([x; y], fs);

